//----------------------------------------------------------------------
// roundtripxml.js
// Author: Bob Dondero
//----------------------------------------------------------------------

// WARNING:  DOESN'T HANDLE PROCESSING INSTRUCTION!!!

'use strict';

const fs = require('fs');
const xmldom = require('xmldom');
const xmlserializer = require('xmlserializer');

//----------------------------------------------------------------------

function parseFile(err, xmlDoc) {
   if (err) {
      process.stderr.write(err.message + '\n');
      process.exit(1);
   }

   // XML to DOM tree:
   let parser = new xmldom.DOMParser();
   let xmlDomTree = parser.parseFromString(xmlDoc, 'text/xml');

   // DOM tree to XML:
   // WARNING:  DOESN'T HANDLE PROCESSING INSTRUCTION!!!
   xmlDoc = xmlserializer.serializeToString(xmlDomTree);

   // Show that it worked:
   process.stdout.write(xmlDoc);
}

//----------------------------------------------------------------------

function main() {
   if (process.argv.length !== 3) {
      process.stderr.write('Usage: ' + process.argv[0] + ' '
         + process.argv[1] + ' file\n');
      process.exit(1);
   }

   let xmlFileName = process.argv[2];

   fs.readFile(xmlFileName, 'utf-8', parseFile);
}

if (require.main === module)
   main();
